#include <Mrm/MrmAppl.h>
#include <Xm/TextF.h>
#include <stdlib.h>
#include <stdio.h>

#define c_Add 0
#define c_Subtract 1
#define c_Multiply 2
#define c_Divide 3

#define c_Operand_1_Field 0
#define c_Operand_2_Field 1

Widget text_operand_1, text_operand_2; 

/* Mrm Variable */

static MrmType class_id;
static MrmType *dummy_class;
static char *uid_filename[] = { "example.uid" };
MrmHierarchy hierarchy;

/* Die Callback-Routinen */

static void Register();
static void Compute();
static void Exit_Application();

/* Die Callback-Liste */

static MrmRegisterArg reglist[] = {
                /* UIL-Name                    Routine */
		/* --------                    ------- */
                { "Register",         (caddr_t)Register},
                { "Compute",          (caddr_t)Compute },
                { "Exit_Application", (caddr_t)Exit_Application }
};

static int reglist_num = 3; /* 3 Callbacks in der obigen Liste */

/* Exit Callback */

static void Exit_Application (Widget w, XtPointer tag,
                              XmAnyCallbackStruct *reason)
{
  exit(1);
}

/* Berechnungs-Callback */

static void Compute (Widget w, int *tag,
                     XmAnyCallbackStruct *reason)
{
  int op1, op2, result;
  char *buff = (char *)malloc(20);

  op1 = atoi(XmTextFieldGetString(text_operand_1));
  op2 = atoi(XmTextFieldGetString(text_operand_2));
  
  switch(*tag) {
    case c_Add:      result = op1 + op2; break;
    case c_Subtract: result = op1 - op2; break;
    case c_Multiply: result = op1 * op2; break;
    case c_Divide:   if(op2)
                       result = op1 / op2;
		     else
		       result = 0; /* Nur um Fehler zu vermeiden */
		     break;
  }
  
  sprintf(buff,"%d",result);
  XmTextFieldSetString(text_operand_1,buff);
  XmTextFieldSetString(text_operand_2,"0");
}

/* Callback zur Registrierung der beiden (implizit erzeugten) */
/* TextField-Widgets.                                         */

static void Register (Widget w, int *tag,
                      XmAnyCallbackStruct *reason)
{
  switch(*tag) {
    case c_Operand_1_Field: text_operand_1 = w; break;
    case c_Operand_2_Field: text_operand_2 = w; break;
  }
}

/* Main */

unsigned int main (int argc, char **argv)
{
  XtAppContext app_context;
  
  Widget toplevel, main_window;

  /* First of all, initialize Mrm */

  MrmInitialize();

  /* X11 initialisieren, Shell-Widget erzeugen */

  toplevel = XtAppInitialize(&app_context,"Example",NULL,0,
                             &argc,argv,NULL,NULL,0);

  /* UID-Datei oeffnen */

  if(MrmOpenHierarchy(1,uid_filename,NULL,&hierarchy) !=MrmSUCCESS) {
    puts("Can't open hierarchy");
    exit(1);
  }

  /* Callbacks "binden" */
  
  MrmRegisterNames(reglist,reglist_num);

  /* Widget-Tree aufbauen */

  MrmFetchWidget(hierarchy,"main_window",toplevel,&main_window,&class_id);

  /* Interface starten */
  
  XtManageChild(main_window);

  XtRealizeWidget(toplevel);
  XtAppMainLoop(app_context);
}

